#THIS FILE IS AUTOMATICLY GENERATED DO NOT MODIFY IT
ConfigVersion := 0.0.10
all :
__internal_enable_groups := 1

problem := histogram

CheckerSrc ?=
CheckerExec ?=
CheckerCommand ?= diff

ValidatorSrc ?= ./src/validate.cpp
ValidatorExec ?= .bin/validate.exe
ValidatorCommand ?= ./.bin/validate.exe

StdoutGenList := gen_mi gen_mi2 gen_ra gen_ra2 gendecr genincr genrand genshuffle twf
GenList := gen_mi gen_mi2 gen_ra gen_ra2 gendecr genincr genrand genshuffle twf

gen_miTests := tests/016 tests/020 tests/047 tests/051 tests/066 tests/067 tests/087 tests/088 tests/111 tests/115 tests/119 tests/123
.DELETE_ON_ERROR : .bin/gen_mi.exe
.SECONDARY : .bin/gen_mi.exe
.bin/gen_mi.exe : src/gen_mi.cpp | .bin
$(gen_miTests) : src/gen_mi.cpp | .bin/gen_mi.exe

gen_mi2Tests := tests/017 tests/021 tests/048 tests/052 tests/068 tests/069 tests/089 tests/090 tests/112 tests/116 tests/120 tests/124
.DELETE_ON_ERROR : .bin/gen_mi2.exe
.SECONDARY : .bin/gen_mi2.exe
.bin/gen_mi2.exe : src/gen_mi2.cpp | .bin
$(gen_mi2Tests) : src/gen_mi2.cpp | .bin/gen_mi2.exe

gen_raTests := tests/014 tests/018 tests/045 tests/049 tests/070 tests/071 tests/091 tests/092 tests/109 tests/113 tests/117 tests/121
.DELETE_ON_ERROR : .bin/gen_ra.exe
.SECONDARY : .bin/gen_ra.exe
.bin/gen_ra.exe : src/gen_ra.cpp | .bin
$(gen_raTests) : src/gen_ra.cpp | .bin/gen_ra.exe

gen_ra2Tests := tests/015 tests/019 tests/046 tests/050 tests/072 tests/073 tests/093 tests/094 tests/110 tests/114 tests/118 tests/122
.DELETE_ON_ERROR : .bin/gen_ra2.exe
.SECONDARY : .bin/gen_ra2.exe
.bin/gen_ra2.exe : src/gen_ra2.cpp | .bin
$(gen_ra2Tests) : src/gen_ra2.cpp | .bin/gen_ra2.exe

gendecrTests := tests/009 tests/011 tests/013 tests/035 tests/036 tests/037 tests/040 tests/041 tests/042 tests/061 tests/062 tests/082 tests/083 tests/104 tests/106 tests/108
.DELETE_ON_ERROR : .bin/gendecr.exe
.SECONDARY : .bin/gendecr.exe
.bin/gendecr.exe : src/gendecr.cpp | .bin
$(gendecrTests) : src/gendecr.cpp | .bin/gendecr.exe

genincrTests := tests/008 tests/010 tests/012 tests/038 tests/039 tests/043 tests/044 tests/063 tests/064 tests/065 tests/084 tests/085 tests/086 tests/103 tests/105 tests/107
.DELETE_ON_ERROR : .bin/genincr.exe
.SECONDARY : .bin/genincr.exe
.bin/genincr.exe : src/genincr.cpp | .bin
$(genincrTests) : src/genincr.cpp | .bin/genincr.exe

genrandTests := tests/003 tests/004 tests/005 tests/006 tests/007 tests/022 tests/023 tests/024 tests/025 tests/026 tests/027 tests/028 tests/029 tests/030 tests/031 tests/032 tests/033 tests/034 tests/053 tests/054 tests/055 tests/056 tests/057 tests/058 tests/059 tests/060 tests/074 tests/075 tests/076 tests/077 tests/078 tests/079 tests/080 tests/081 tests/095 tests/096 tests/097 tests/098 tests/099 tests/100 tests/101 tests/102 tests/125 tests/126 tests/127
.DELETE_ON_ERROR : .bin/genrand.exe
.SECONDARY : .bin/genrand.exe
.bin/genrand.exe : src/genrand.cpp | .bin
$(genrandTests) : src/genrand.cpp | .bin/genrand.exe

genshuffleTests := tests/008 tests/009 tests/010 tests/011 tests/035 tests/036 tests/037 tests/038 tests/039 tests/040 tests/041 tests/042 tests/043 tests/044 tests/061 tests/062 tests/063 tests/064 tests/065 tests/066 tests/067 tests/068 tests/069 tests/070 tests/071 tests/072 tests/073 tests/082 tests/083 tests/084 tests/085 tests/086 tests/087 tests/088 tests/089 tests/090 tests/091 tests/092 tests/093 tests/094 tests/103 tests/104 tests/105 tests/106
.DELETE_ON_ERROR : .bin/genshuffle.exe
.SECONDARY : .bin/genshuffle.exe
.bin/genshuffle.exe : src/genshuffle.cpp | .bin
$(genshuffleTests) : src/genshuffle.cpp | .bin/genshuffle.exe

twfTests := tests/001 tests/002
.DELETE_ON_ERROR : .bin/twf.exe
.SECONDARY : .bin/twf.exe
.bin/twf.exe : src/twf.c | .bin
$(twfTests) : src/twf.c | .bin/twf.exe


HandTestsFile :=
HandTests := tests/001 tests/002
$(HandTests) : tests/% : src/%.hand

CPPSolSrc := solutions/histogram_egorshcherbin_nm.cpp solutions/histogram_mi_nsqrtnlogn.cpp solutions/histogram_mi_n2.cpp solutions/histogram_egorshcherbin_nm_wa.cpp solutions/histogram_mi_nlogn.cpp
CPPSolExec := $(CPPSolSrc:solutions/%.cpp=.bin/%.exe)
CPPSolShortNames := $(CPPSolExec:.bin/histogram_%.exe=%)

CSolSrc :=
CSolExec := $(CSolSrc:solutions/%.c=.bin/%.exe)
CSolShortNames := $(CSolExec:.bin/histogram_%.exe=%)

JAVASolSrc :=
JAVASolExec := $(JAVASolSrc:solutions/%.java=.bin/%.jar)
JAVASolShortNames := $(JAVASolExec:.bin/histogram_%.jar=%)

PYSolSrc :=
PYSolExec := $(PYSolSrc:solutions/%.py=.bin/%.py)
PYSolShortNames := $(PYSolExec:.bin/histogram_%.py=%)

PASSolSrc :=
PASSolExec := $(PASSolSrc:solutions/%.pas=.bin/%.exe)
PASSolShortNames := $(PASSolExec:.bin/histogram_%.exe=%)

DPRSolSrc :=
DPRSolExec := $(DPRSolSrc:solutions/%.dpr=.bin/%.exe)
DPRSolShortNames := $(DPRSolExec:.bin/histogram_%.exe=%)

DSolSrc :=
DSolExec := $(DSolSrc:solutions/%.d=.bin/%.exe)
DSolShortNames := $(DSolExec:.bin/histogram_%.exe=%)

SolSrc := $(foreach ext,CPP C JAVA PY PAS DPR D,$($(ext)SolSrc))
SolExec := $(foreach ext,CPP C JAVA PY PAS DPR D,$($(ext)SolExec))
SolShortNames := $(foreach ext,CPP C JAVA PY PAS DPR D,$($(ext)SolShortNames))

Tests := 001 002 003 004 005 006 007 008 009 010 011 012 013 014 015 016 017 018 019 020 021 022 023 024 025 026 027 028 029 030 031 032 033 034 035 036 037 038 039 040 041 042 043 044 045 046 047 048 049 050 051 052 053 054 055 056 057 058 059 060 061 062 063 064 065 066 067 068 069 070 071 072 073 074 075 076 077 078 079 080 081 082 083 084 085 086 087 088 089 090 091 092 093 094 095 096 097 098 099 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
InDirTests := $(Tests:%=tests/%)
TestsValidateFlags := $(Tests:%=.__temp__/%.val)
TestsGenerateFlags := $(Tests:%=.__temp__/%.gen)
TestAnswers := $(Tests:%=%.a)
InDirTestAnswers := $(Tests:%=tests/%.a)
FileTests :=
MultiGenTests :=

Gen001Line := ./twf.exe <../src/001.hand
Gen002Line := ./twf.exe <../src/002.hand
Gen003Line := ./genrand.exe 1 9991 1000000000 10000
Gen004Line := ./genrand.exe 1 9992 999999999 9999
Gen005Line := ./genrand.exe 1 9993 999999998 9998
Gen006Line := ./genrand.exe 1 9994 999999997 9997
Gen007Line := ./genrand.exe 1 9995 999999996 9996
Gen008Line := ./genincr.exe 1 9991 1000000000 10000 | ./genshuffle.exe 333 1000000
Gen009Line := ./gendecr.exe 1 9991 1000000000 10000 | ./genshuffle.exe 333 1000000
Gen010Line := ./genincr.exe 1 9992 999999999 9999 | ./genshuffle.exe 333 1000000
Gen011Line := ./gendecr.exe 1 9992 999999999 9999 | ./genshuffle.exe 333 1000000
Gen012Line := ./genincr.exe 1 9993 999999998 9998
Gen013Line := ./gendecr.exe 1 9993 999999998 9998
Gen014Line := ./gen_ra.exe 1 10000 1000000000 10000 100
Gen015Line := ./gen_ra2.exe 1 10000 1000000000 10000 100
Gen016Line := ./gen_mi.exe 1 10000 1000000000 10000 100
Gen017Line := ./gen_mi2.exe 1 10000 1000000000 10000 100
Gen018Line := ./gen_ra.exe 1 10000 1000000000 10000 10
Gen019Line := ./gen_ra2.exe 1 10000 1000000000 10000 10
Gen020Line := ./gen_mi.exe 1 10000 1000000000 10000 10
Gen021Line := ./gen_mi2.exe 1 10000 1000000000 10000 10
Gen022Line := ./genrand.exe 1 1 0 10000
Gen023Line := ./genrand.exe 1 2 1 10000
Gen024Line := ./genrand.exe 1 2 0 10000
Gen025Line := ./genrand.exe 2 10 100000 10
Gen026Line := ./genrand.exe 2 11 90909 11
Gen027Line := ./genrand.exe 2 12 83333 12
Gen028Line := ./genrand.exe 2 13 76923 13
Gen029Line := ./genrand.exe 2 14 71428 14
Gen030Line := ./genrand.exe 2 100000 10 100000
Gen031Line := ./genrand.exe 2 90909 11 90909
Gen032Line := ./genrand.exe 2 83333 12 83333
Gen033Line := ./genrand.exe 2 76923 13 76923
Gen034Line := ./genrand.exe 2 71428 14 71428
Gen035Line := ./gendecr.exe 2 10 100000 10 | ./genshuffle.exe 4 10
Gen036Line := ./gendecr.exe 2 11 90909 11 | ./genshuffle.exe 4 10
Gen037Line := ./gendecr.exe 2 12 83333 12 | ./genshuffle.exe 4 10
Gen038Line := ./genincr.exe 2 10 100000 10 | ./genshuffle.exe 4 10
Gen039Line := ./genincr.exe 2 11 90909 11 | ./genshuffle.exe 4 10
Gen040Line := ./gendecr.exe 2 100000 10 100000 | ./genshuffle.exe 4 10
Gen041Line := ./gendecr.exe 2 90909 11 90909 | ./genshuffle.exe 4 10
Gen042Line := ./gendecr.exe 2 83333 12 83333 | ./genshuffle.exe 4 10
Gen043Line := ./genincr.exe 2 100000 10 100000 | ./genshuffle.exe 4 10
Gen044Line := ./genincr.exe 2 90909 11 90909 | ./genshuffle.exe 4 10
Gen045Line := ./gen_ra.exe 2 1000 1000 1000 100
Gen046Line := ./gen_ra2.exe 2 100000 10 100000 100
Gen047Line := ./gen_mi.exe 2 10000 100 10000 10
Gen048Line := ./gen_mi2.exe 2 10000 100 10000 10
Gen049Line := ./gen_ra.exe 2 10 100000 10 100
Gen050Line := ./gen_ra2.exe 2 100000 10 100000 10000
Gen051Line := ./gen_mi.exe 2 10000 100 10000 100
Gen052Line := ./gen_mi2.exe 2 10000 100 10000 100
Gen053Line := ./genrand.exe 2 1 0 1
Gen054Line := ./genrand.exe 2 2 1 2
Gen055Line := ./genrand.exe 2 2 0 2
Gen056Line := ./genrand.exe 3 99996 10000 99996
Gen057Line := ./genrand.exe 3 99997 9999 99997
Gen058Line := ./genrand.exe 3 99998 9998 99998
Gen059Line := ./genrand.exe 3 99999 9997 99999
Gen060Line := ./genrand.exe 3 100000 9996 100000
Gen061Line := ./gendecr.exe 3 99989 99899 99989 | ./genshuffle.exe 4000 400
Gen062Line := ./gendecr.exe 3 99990 99900 99990 | ./genshuffle.exe 4000 400
Gen063Line := ./genincr.exe 3 99989 99899 99989 | ./genshuffle.exe 4000 400
Gen064Line := ./genincr.exe 3 99990 99900 99990 | ./genshuffle.exe 4000 400
Gen065Line := ./genincr.exe 3 99991 99901 99991 | ./genshuffle.exe 4000 400
Gen066Line := ./gen_mi.exe 3 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen067Line := ./gen_mi.exe 3 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen068Line := ./gen_mi2.exe 3 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen069Line := ./gen_mi2.exe 3 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen070Line := ./gen_ra.exe 3 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen071Line := ./gen_ra.exe 3 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen072Line := ./gen_ra2.exe 3 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen073Line := ./gen_ra2.exe 3 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen074Line := ./genrand.exe 3 1 0 1
Gen075Line := ./genrand.exe 3 2 1 2
Gen076Line := ./genrand.exe 3 2 0 2
Gen077Line := ./genrand.exe 4 99996 10000 99996
Gen078Line := ./genrand.exe 4 99997 9999 99997
Gen079Line := ./genrand.exe 4 99998 9998 99998
Gen080Line := ./genrand.exe 4 99999 9997 99999
Gen081Line := ./genrand.exe 4 100000 9996 100000
Gen082Line := ./gendecr.exe 4 99989 99899 99989 | ./genshuffle.exe 4000 400
Gen083Line := ./gendecr.exe 4 99990 99900 99990 | ./genshuffle.exe 4000 400
Gen084Line := ./genincr.exe 4 99989 99899 99989 | ./genshuffle.exe 4000 400
Gen085Line := ./genincr.exe 4 99990 99900 99990 | ./genshuffle.exe 4000 400
Gen086Line := ./genincr.exe 4 99991 99901 99991 | ./genshuffle.exe 4000 400
Gen087Line := ./gen_mi.exe 4 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen088Line := ./gen_mi.exe 4 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen089Line := ./gen_mi2.exe 4 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen090Line := ./gen_mi2.exe 4 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen091Line := ./gen_ra.exe 4 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen092Line := ./gen_ra.exe 4 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen093Line := ./gen_ra2.exe 4 99989 99899 99989 1000 | ./genshuffle.exe 4000 400
Gen094Line := ./gen_ra2.exe 4 99990 99900 99990 1000 | ./genshuffle.exe 4000 400
Gen095Line := ./genrand.exe 4 1 0 1
Gen096Line := ./genrand.exe 4 2 1 2
Gen097Line := ./genrand.exe 4 2 0 2
Gen098Line := ./genrand.exe 5 99991 1000000000 100000
Gen099Line := ./genrand.exe 5 99992 999999999 99999
Gen100Line := ./genrand.exe 5 99993 999999998 99998
Gen101Line := ./genrand.exe 5 99994 999999997 99997
Gen102Line := ./genrand.exe 5 99995 999999996 99996
Gen103Line := ./genincr.exe 5 99991 1000000000 100000 | ./genshuffle.exe 3333 1000000
Gen104Line := ./gendecr.exe 5 99991 1000000000 100000 | ./genshuffle.exe 3333 1000000
Gen105Line := ./genincr.exe 5 99992 999999999 99999 | ./genshuffle.exe 3333 1000000
Gen106Line := ./gendecr.exe 5 99992 999999999 99999 | ./genshuffle.exe 3333 1000000
Gen107Line := ./genincr.exe 5 99993 999999998 99998
Gen108Line := ./gendecr.exe 5 99993 999999998 99998
Gen109Line := ./gen_ra.exe 5 100000 1000000000 100000 100
Gen110Line := ./gen_ra2.exe 5 100000 1000000000 100000 100
Gen111Line := ./gen_mi.exe 5 100000 1000000000 100000 100
Gen112Line := ./gen_mi2.exe 5 100000 1000000000 100000 100
Gen113Line := ./gen_ra.exe 5 100000 1000000000 100000 10
Gen114Line := ./gen_ra2.exe 5 100000 1000000000 100000 10
Gen115Line := ./gen_mi.exe 5 100000 1000000000 100000 10
Gen116Line := ./gen_mi2.exe 5 100000 1000000000 100000 10
Gen117Line := ./gen_ra.exe 5 100000 1000000000 100000 10000
Gen118Line := ./gen_ra2.exe 5 100000 1000000000 100000 10000
Gen119Line := ./gen_mi.exe 5 100000 1000000000 100000 10000
Gen120Line := ./gen_mi2.exe 5 100000 1000000000 100000 1000
Gen121Line := ./gen_ra.exe 5 100000 1000000000 100000 1000
Gen122Line := ./gen_ra2.exe 5 100000 1000000000 100000 1000
Gen123Line := ./gen_mi.exe 5 100000 1000000000 100000 1000
Gen124Line := ./gen_mi2.exe 5 100000 1000000000 100000 10000
Gen125Line := ./genrand.exe 5 1 0 100000 seed5
Gen126Line := ./genrand.exe 5 2 1 100000 seed5
Gen127Line := ./genrand.exe 5 2 0 100000 seed5

Test001Group := 0
Test002Group := 0
Test003Group := 1
Test004Group := 1
Test005Group := 1
Test006Group := 1
Test007Group := 1
Test008Group := 1
Test009Group := 1
Test010Group := 1
Test011Group := 1
Test012Group := 1
Test013Group := 1
Test014Group := 1
Test015Group := 1
Test016Group := 1
Test017Group := 1
Test018Group := 1
Test019Group := 1
Test020Group := 1
Test021Group := 1
Test022Group := 1
Test023Group := 1
Test024Group := 1
Test025Group := 2
Test026Group := 2
Test027Group := 2
Test028Group := 2
Test029Group := 2
Test030Group := 2
Test031Group := 2
Test032Group := 2
Test033Group := 2
Test034Group := 2
Test035Group := 2
Test036Group := 2
Test037Group := 2
Test038Group := 2
Test039Group := 2
Test040Group := 2
Test041Group := 2
Test042Group := 2
Test043Group := 2
Test044Group := 2
Test045Group := 2
Test046Group := 2
Test047Group := 2
Test048Group := 2
Test049Group := 2
Test050Group := 2
Test051Group := 2
Test052Group := 2
Test053Group := 2
Test054Group := 2
Test055Group := 2
Test056Group := 3
Test057Group := 3
Test058Group := 3
Test059Group := 3
Test060Group := 3
Test061Group := 3
Test062Group := 3
Test063Group := 3
Test064Group := 3
Test065Group := 3
Test066Group := 3
Test067Group := 3
Test068Group := 3
Test069Group := 3
Test070Group := 3
Test071Group := 3
Test072Group := 3
Test073Group := 3
Test074Group := 3
Test075Group := 3
Test076Group := 3
Test077Group := 4
Test078Group := 4
Test079Group := 4
Test080Group := 4
Test081Group := 4
Test082Group := 4
Test083Group := 4
Test084Group := 4
Test085Group := 4
Test086Group := 4
Test087Group := 4
Test088Group := 4
Test089Group := 4
Test090Group := 4
Test091Group := 4
Test092Group := 4
Test093Group := 4
Test094Group := 4
Test095Group := 4
Test096Group := 4
Test097Group := 4
Test098Group := 5
Test099Group := 5
Test100Group := 5
Test101Group := 5
Test102Group := 5
Test103Group := 5
Test104Group := 5
Test105Group := 5
Test106Group := 5
Test107Group := 5
Test108Group := 5
Test109Group := 5
Test110Group := 5
Test111Group := 5
Test112Group := 5
Test113Group := 5
Test114Group := 5
Test115Group := 5
Test116Group := 5
Test117Group := 5
Test118Group := 5
Test119Group := 5
Test120Group := 5
Test121Group := 5
Test122Group := 5
Test123Group := 5
Test124Group := 5
Test125Group := 5
Test126Group := 5
Test127Group := 5

